#!/bin/bash

#==========================================================#
# Solitaire BG v1.0 by SFR (@ murga-linux.com/puppy) '2012 #
#==========================================================#

# =================================
# 			PREPARATIONS
# =================================

trap DelTemp EXIT

export S_PATH=/tmp/Solitaire_BG_Temp$$/
mkdir "$S_PATH"

echo 44 > "$S_PATH"Last
echo 44 > "$S_PATH"Current

# Create Empty Cell:
echo '<svg width="24" height="24" version="1.1" xmlns="http://www.w3.org/2000/svg">
</svg>' > "$S_PATH"Cell_Empty.svg

# Create Full Cell:
echo '<svg width="24" height="24" version="1.1" xmlns="http://www.w3.org/2000/svg">
<circle cx="12" cy="12" r="6" fill="black" />
</svg>' > "$S_PATH"Cell_Full.svg

# Create 'actions' cluster for each button
ACTIONS="<action>TestCell</action>"
for i in {3..5}; do
  ACTIONS=`echo "$ACTIONS<action>refresh:C"$i"1</action>"`
  ACTIONS=`echo "$ACTIONS<action>refresh:C"$i"2</action>"`
  ACTIONS=`echo "$ACTIONS<action>refresh:C"$i"6</action>"`
  ACTIONS=`echo "$ACTIONS<action>refresh:C"$i"7</action>"`
done
for i in {1..7}; do
  ACTIONS=`echo "$ACTIONS<action>refresh:C"$i"3</action>"`
  ACTIONS=`echo "$ACTIONS<action>refresh:C"$i"4</action>"`
  ACTIONS=`echo "$ACTIONS<action>refresh:C"$i"5</action>"`
done

# Create GtkDialog tags for each button
X=3
Y=1
for i in {1..6}; do
  BUT[$i]="<button width-request=\"30\" height-request=\"30\"><variable>C$X$Y</variable><input file>"$S_PATH"Cell_"$X"-"$Y"</input><action>echo $X$Y > "$S_PATH"Current</action>$ACTIONS</button>"
  let X=X+1
  if [ "$X" -eq 6 ]; then X=3; let Y=Y+1; fi
done

X=1
Y=3
for i in {7..27}; do
  BUT[$i]="<button width-request=\"30\" height-request=\"30\"><variable>C$X$Y</variable><input file>"$S_PATH"Cell_"$X"-"$Y"</input><action>echo $X$Y > "$S_PATH"Current</action>$ACTIONS</button>"
  let X=X+1
  if [ "$X" -eq 8 ]; then X=1; let Y=Y+1; fi
done

X=3
Y=6
for i in {28..33}; do
  BUT[$i]="<button width-request=\"30\" height-request=\"30\"><variable>C$X$Y</variable><input file>"$S_PATH"Cell_"$X"-"$Y"</input><action>echo $X$Y > "$S_PATH"Current</action>$ACTIONS</button>"
  let X=X+1
  if [ "$X" -eq 6 ]; then X=3; let Y=Y+1; fi
done

# It was really unpleasant surprise, when I found out that BASH doesn't export arrays...
export BUT1=${BUT[1]}
export BUT2=${BUT[2]}
export BUT3=${BUT[3]}
export BUT4=${BUT[4]}
export BUT5=${BUT[5]}
export BUT6=${BUT[6]}
export BUT7=${BUT[7]}
export BUT8=${BUT[8]}
export BUT9=${BUT[9]}
export BUT10=${BUT[10]}
export BUT11=${BUT[11]}
export BUT12=${BUT[12]}
export BUT13=${BUT[13]}
export BUT14=${BUT[14]}
export BUT15=${BUT[15]}
export BUT16=${BUT[16]}
export BUT17=${BUT[17]}
export BUT18=${BUT[18]}
export BUT19=${BUT[19]}
export BUT20=${BUT[20]}
export BUT21=${BUT[21]}
export BUT22=${BUT[22]}
export BUT23=${BUT[23]}
export BUT24=${BUT[24]}
export BUT25=${BUT[25]}
export BUT26=${BUT[26]}
export BUT27=${BUT[27]}
export BUT28=${BUT[28]}
export BUT29=${BUT[29]}
export BUT30=${BUT[30]}
export BUT31=${BUT[31]}
export BUT32=${BUT[32]}
export BUT33=${BUT[33]}

# ============================
# 			FUNCTIONS
# ============================

DelTemp () {
  rm -rf /tmp/Solitaire_BG_Temp$$
}

function Setup () {
  # Create symlink for each cell's state
  for y in {1..7}; do
    for x in {1..7}; do 
      ln -sf "$S_PATH"Cell_Full.svg "$S_PATH"Cell_"$x"-"$y"
    done
  done
  ln -sf "$S_PATH"Cell_Empty.svg "$S_PATH"Cell_4-4
}
export -f Setup

function TestCell () {
  LAST=`cat "$S_PATH"Last`
  LX=`echo ${LAST:0:1}`
  LY=`echo ${LAST:1:1}`
  
  CURRENT=`cat "$S_PATH"Current`
  CX=`echo ${CURRENT:0:1}`
  CY=`echo ${CURRENT:1:1}`
  
  echo $CURRENT > "$S_PATH"Last
    
  LASTSTATE=`stat -c %N "$S_PATH"Cell_"$LX"-"$LY" | grep -i 'Empty'`
  CURRENTSTATE=`stat -c %N "$S_PATH"Cell_"$CX"-"$CY" | grep -i 'Empty'`

  # Testing conditions and modifying cells' state
  # (Children, don't do it at home - it's an example of bad, bloated code ;)
  
  # From down to up
  if [ "$LX" -eq "$CX" ]; then
    TEST=$(($LY-$CY))
    if [ "$TEST" -eq 2 ]; then
      TEST=$(($LY-1))
      MIDDLESTATE=`stat -c %N "$S_PATH"Cell_"$CX"-"$TEST" | grep -i 'Empty'`
      if [ "$LASTSTATE" = "" ] && [ "$CURRENTSTATE" != "" ] && [ "$MIDDLESTATE" = "" ]; then
        ln -sf "$S_PATH"Cell_Empty.svg "$S_PATH"Cell_"$LX"-"$LY"
        ln -sf "$S_PATH"Cell_Empty.svg "$S_PATH"Cell_"$LX"-"$TEST"
        ln -sf "$S_PATH"Cell_Full.svg "$S_PATH"Cell_"$CX"-"$CY"
      fi     
    fi
  fi
  
  # From up to down
  if [ "$LX" -eq "$CX" ]; then
    TEST=$(($CY-$LY))
    if [ "$TEST" -eq 2 ]; then
      TEST=$(($LY+1))
      MIDDLESTATE=`stat -c %N "$S_PATH"Cell_"$CX"-"$TEST" | grep -i 'Empty'`
      if [ "$LASTSTATE" = "" ] && [ "$CURRENTSTATE" != "" ] && [ "$MIDDLESTATE" = "" ]; then
        ln -sf "$S_PATH"Cell_Empty.svg "$S_PATH"Cell_"$LX"-"$LY"
        ln -sf "$S_PATH"Cell_Empty.svg "$S_PATH"Cell_"$LX"-"$TEST"
        ln -sf "$S_PATH"Cell_Full.svg "$S_PATH"Cell_"$CX"-"$CY"
      fi     
    fi
  fi  
  
  # From left to right
  if [ "$LY" -eq "$CY" ]; then
    TEST=$(($CX-$LX))
    if [ "$TEST" -eq 2 ]; then
      TEST=$(($LX+1))
      MIDDLESTATE=`stat -c %N "$S_PATH"Cell_"$TEST"-"$CY" | grep -i 'Empty'`
      if [ "$LASTSTATE" = "" ] && [ "$CURRENTSTATE" != "" ] && [ "$MIDDLESTATE" = "" ]; then
        ln -sf "$S_PATH"Cell_Empty.svg "$S_PATH"Cell_"$LX"-"$LY"
        ln -sf "$S_PATH"Cell_Empty.svg "$S_PATH"Cell_"$TEST"-"$LY"
        ln -sf "$S_PATH"Cell_Full.svg "$S_PATH"Cell_"$CX"-"$CY"
      fi     
    fi
  fi
  
  # From right to left
  if [ "$LY" -eq "$CY" ]; then
    TEST=$(($LX-$CX))
    if [ "$TEST" -eq 2 ]; then
      TEST=$(($LX-1))
      MIDDLESTATE=`stat -c %N "$S_PATH"Cell_"$TEST"-"$CY" | grep -i 'Empty'`
      if [ "$LASTSTATE" = "" ] && [ "$CURRENTSTATE" != "" ] && [ "$MIDDLESTATE" = "" ]; then
        ln -sf "$S_PATH"Cell_Empty.svg "$S_PATH"Cell_"$LX"-"$LY"
        ln -sf "$S_PATH"Cell_Empty.svg "$S_PATH"Cell_"$TEST"-"$LY"
        ln -sf "$S_PATH"Cell_Full.svg "$S_PATH"Cell_"$CX"-"$CY"
      fi     
    fi
  fi 
}
export -f TestCell

# ======================
# 			GUI
# ======================

export MAIN='
<window title="Solitaire BG v1.0" allow-grow="false">
  <vbox>
    <frame Options:>
      <hbox>
        <button width-request="175" height-request="30">
          <label>Start New Game</label>
          <action>Setup</action>
          '$ACTIONS'
        </button>
        <button width-request="65" height-request="30">
          <label>Exit</label>
          <action>exit:EXIT</action>
        </button>
      </hbox>
    </frame>
    
    <frame Gameboard:>
      <hbox>
        <button width-request="64" height-request="64" sensitive="false" relief="2"><label>" "</label></button>
          <vbox>       
            <hbox>
              '$BUT1'
              '$BUT2'
              '$BUT3'
            </hbox>
            <hbox>
              '$BUT4'
              '$BUT5'
              '$BUT6'
            </hbox>
          </vbox>
        <button width-request="65" height-request="64" sensitive="false" relief="2"><label>" "</label></button>
      </hbox>
      <hbox>
        '$BUT7'
        '$BUT8'
        '$BUT9'
        '$BUT10'
        '$BUT11'
        '$BUT12'
        '$BUT13'
      </hbox>
      <hbox>
        '$BUT14'
        '$BUT15'
        '$BUT16'
        '$BUT17'
        '$BUT18'
        '$BUT19'
        '$BUT20'
      </hbox> 
      <hbox>
        '$BUT21'
        '$BUT22'
        '$BUT23'
        '$BUT24'
        '$BUT25'
        '$BUT26'
        '$BUT27'
      </hbox>   
      <hbox>
        <button width-request="64" height-request="64" sensitive="false" relief="2"><label>" "</label></button>
          <vbox>
            <hbox>
              '$BUT28'
              '$BUT29'
              '$BUT30'
            </hbox>
            <hbox>
              '$BUT31'
              '$BUT32'
              '$BUT33'
            </hbox>
          </vbox>
        <button width-request="65" height-request="64" sensitive="false" relief="2"><label>" "</label></button>
      </hbox>
    </frame>
  </vbox>
</window>
'
# =========================
# 			START
# =========================

Setup
gtkdialog -c -p MAIN
exit 0

### THE END ###
